<template>
  <div
    ref="panelWrapper"
    :class="$style['panelwrapper']"
  >
    <section
      :class="[
        $style['panel'],
        $style['panel-left'],
        STATE.rightPanelOpen ? null : $style['is-full'],
      ]"
    >
      <slot name="left" />
    </section>
    <section
      :class="[
        $style['panel'],
        $style['panel-right'],
        STATE.rightPanelOpen ? null : $style['is-offscreen'],
      ]"
    >
      <div :class="$style['panel-right-inner']">
        <slot name="right" />
      </div>
    </section>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  inject,
  ref,
  watchEffect,
} from "@nuxtjs/composition-api";

export default defineComponent({
  name: "AmsTwoPanels",

  props: {
    panelWidths: {
      type: Array,
      default: () => [null, null],
    },
  },

  setup (props) {
    const { STATE } = inject("store");

    const panelWrapper = ref(null);

    const stopWatchPanelWrapper = watchEffect(() => {
      if (panelWrapper.value) {
        if (props.panelWidths[0]) {
          panelWrapper.value.style.setProperty("--panel-left-width", props.panelWidths[0]);
        }

        stopWatchPanelWrapper();
      }
    });

    return {
      STATE,
      panelWrapper,
    };
  },
});
</script>

<style lang="postcss" module>
.panelwrapper {
  --panel-left-width: 55%;
  --panel-right-width: calc(100% - var(--panel-left-width));
  --slide-duration: 250ms;
  --slide-timing-fn: ease;

  height: calc(100vh - var(--appheader-height, 4.375rem));

  @apply relative flex flex-col-reverse justify-end items-center text-center mx-auto w-full max-w-none;

  @screen lg {
    @apply flex-row justify-start;

    .panel {
      min-width: calc(320px - var(--appsidebar-width, 6rem));
      max-width: calc(100vw - var(--appsidebar-width, 6rem));

      @apply h-full;
    }

    .panel-left {
      flex: 0 1 auto;
      width: calc(var(--panel-left-width) - 1px);
    }

    .panel-right {
      flex: 0 1 auto;
      width: calc(var(--panel-right-width) - 1px);

      @apply overflow-hidden;
    }
  }

  .panel {
    @apply relative min-w-0 max-w-none h-full;
  }

  .panel-left {
    transition: width var(--slide-duration) var(--slide-timing-fn);

    &.is-full {
      width: calc(100% + 0px);

      @apply absolute left-0 h-full;
    }
  }

  .panel-right {
    transition: width var(--slide-duration) var(--slide-timing-fn);

    &.is-offscreen {
      width: 0;

      @apply absolute right-0;
    }

    &-inner {
      @apply relative top-0 right-0 w-full h-full;
    }
  }
}
</style>
